# cc2-gr2.py - Automne 2016

# Q1.

def contient_chiffre(n, c) :
    return str(c) in str(n)

# Q2a
def fibo(n) :
    if n < 2 : return 1
    return fibo(n-1) + fibo(n-2)

# Q2b
memo = {0:1, 1:1}   # les deux premiers termes

def fibo_memo(n) :
    try :
        f1 = memo[n-1]
    except KeyError :
        f1 = fibo_memo(n-1)
        memo[n-1] = f1
    f2 = memo[n-2]
    return f1 - 2 * f2

print('fibo_memo(100) =',fibo_memo(100))    # rapide !

# Q3a

s = [[1, -2, 0], [2, 3, 1]]

# Q3b

def determinant(s) :
    return s[0][0]*s[1][1] - s[1][0]*s[0][1]    # lourd !

def determinant(s) :
    [[a1,b1,c1],[a2,b2,c2]] = s       # destructuration de s
    return a1*b2 - a2*b1

# Q3c

def resoud(s) :
    det = determinant(s)
    if det == 0 : return False
    [[a1,b1,c1],[a2,b2,c2]] = s       # destructuration de s
    return ((c1*b2 - c2*b1) / det, (a1*c2 - a2*c1) / det)
    
# Q4
from turtle import *

def dessine_polygone(p) :
    m0 = p[0]
    up() ; goto(m0) ; down()
    for m in p :
        goto(m)
    goto(m0)    # on referme le polygone

ht()
tracer(False)
dessine_polygone([(0,0), (100,0), (100,100), (0,100)])
tracer(True)

### Q5
##
## Si les puissances des polynômes considérés sont peu présentes (beaucoup de
## coefficients nuls), la représentation creuse est la plus adaptée (exemple
## extrême x**100). Si beaucoup de puissances sont présentes, la représentation
## dense est plus adaptée (exemple extrême x**100 + x**99 + ... + x + 1)
## Si la moitié des puissances sont présentes alors les deux représentations
## se valent.




    
        
        
    


    
    
    
